#ifndef OUTPUT_H
#define OUTPUT_H
#include <stdio.h>
#include "descrip.h"

/// main output function
long output(FILE *out, descrip *d);
/// output nodes
long wr_nodes(FILE *out, long nprop);
/// output nodes for layered problems
long wr_lay_nodes(FILE *out, long nprop);
/// output boundary conditions
long wr_bocon(FILE *out, long nprop);
/// output elements
long wr_elements(FILE *out, long nprop, descrip *d);
/// output elements for layered problems
long wr_lay_elements(FILE *out, long nprop, descrip *d);
/// output global node numbers for paralell computing
long wr_globnodnum(long id,FILE *out);
/// output integration point section (already not used)
long wr_intpoints(FILE *out, long nprop);
/// output materials
long wr_materials(FILE *out);
/// output auxiliary point section
long wr_auxpoint(FILE *out, long nprop);
/// output section with local coordinate systems on the elements
long wr_ellcsys(FILE *out, long nprop);
/// output cross-sections
long wr_crsecs(FILE *out);
/// load controling function
long wr_load(FILE *out, long npropn, long nprope);
//long wr_dload(FILE *out, long npropn, long nprope);
/// output nodal load
long wr_loadn(FILE *out, long nprop, long nlc);
/// output element load
long wr_loadel(FILE *out, long nprope, long npropn, long nlc);
/// output element edge load
long wr_loadeledg(FILE *out, long nprop, long nlc);
/// auxiliary function for searching elements with loaded edges
long search_loadedg_el(long nprop, long nlc);
/// auxiliary function for searching elements with loaded edges
long search_loadsurf_el(long nprop, long nlc);
/// output element surface load
long wr_loadelsurf(FILE *out, long nprop, long nlc);
/// output nodal dynamical load
long wr_dloadn(FILE *out, long nprop, long nlc);
/// output element dynamical load
long wr_dloadel(FILE *out, long nprop, long nlc);
/// output prescribed displacements
long wr_prescdisp(FILE *out, long nprop, long nlc);
/// output dynamical prescribed displacements
long wr_dprescdisp(FILE *out, long nprop, long nlc);
/// output temperature load
long wr_tempload(FILE *out, long nprop, long nlc);
/// output initial conditions
long wr_initcond(FILE *out, long nprop, long nlc);

#endif
