#ifndef ADAPTIVITY_H
#define ADAPTIVITY_H

class adaptivity
{
 public:
  adaptivity ();
  ~adaptivity ();
  
  long run (long of,int width,long nincr);
  
 private:
  void prepare_ni (int w,long i);
  void prepare_strain (void);
  void spr (void);
  void spr_nonlinear (void);
  void compute_error (void);
  void lin_error (void);
  void nonlin_error (void);

  void compute_refsizel_nonlin ( double *sizel, double *ei2, double *ui2,long ord,long ne,double *refsizel);

  void compute_refsizel_nonlin (double *refsizel,double *sizel,double *ei2,double u2,double e2,long ord,long ne);

  
  void compute_refsizel_lin ( double *sizel, double *ei2,double e2,double u2,long ord,long ne,double *refsizel);
  void compute_epsil_nonlin ( double *ei2, double *ui2,long ne,double *epsil,double &e2,double &u2);
  void print (double volume,double e2,double u2, double *ei2, double *ui2, double *refsizel);
  void print_test ( double *refsizel);
  
  void compute_error_fine (void);
  void print_thetacon ( const char *typfile, long *numnodel,long **nodeadjelem,long nncm,long necm,double **xyrr,long **etnodes, double *theta);
  void print_coarsemesh ( double *ei2);
  
  
  ///  dimension of solved problem
  long dim;
  
  ///  order of base functions of every element
  long ord;
  
  ///  number of components of stress and strain tensors of every element
  long ncomp;
  
  ///  number of nodes of solved problem
  long nn;
  
  ///  number of elements of solved problem
  long ne;
  
  ///  type of error smoothing ; 1 = spr_smoothing , 2 = z2_smoothing
  long tad;
  
  ///  sum of printing flags:
  ///  1  - print stdout     - printing of solving information on standard output
  ///  2  - print bgm        - printing of file.bgm necessary for new mesh generation by T3d generator, file contains required element sizes on points(of old mesh) 
  ///  4  - print contoures  - printing of file.dx(.ex)
  ///  8  - print cmeshch.*  - printing of file 'cmeshchr.x' for FINE solving
  ///  16 - print test       - printing of file.test for testing
  ///  32 - print dx         - printing of file.dx(.ex)
  long printflags;
  
  ///  sum of other flags:
  ///  1 - linear (0) X nonlinear(1) compute_refsizel
  ///  2 - spr compute with strain(0) X stress(1)
  ///  4 - (strain X stress) is own(0) X another(2)
  ///  8 - zienkiewiczuv zpusob nelin pocitani(8) X ostatni(0)
  ///    2 - strain is own(0) X another(1)
  ///    4 - stress is own(0) X another(2)
  long otherflags;
  
  ///  second suffix of enter file, it contains actual nuber of iteration
  char *ni;
  
  ///  array of refined derivatives (stress or strain) in nodes
  double *rderfull;
  
  ///  answer of this class ; 1(0) == remeshing is (is not) recommended
  long answer;
  
  ///  corr
  double corr;

  double clos;
  double plra;
  
  ///  limf
  double limf;
  
 public:
  ///  indicator of integration points on elements; 1 = usual , 0 = unusual
  long *body;
  
};


#endif
