#ifndef DLOADCASE_H
#define DLOADCASE_H

#include "iotools.h"
#include "genfile.h"
#include "alias.h"
#include "seismtool.h"

class dloadn;
class dloadpd;
class loadcase;

/**
   class dloadcase defines load cases in dynamic problems
   
   JK, 27.9.2004
*/

class dloadcase
{
 public:
  dloadcase (void);
  ~dloadcase (void);
  void read (XFILE *in);
  void assemble (long lcid,double *rhs,double *flv,long n, double t);
  void assemble (double *rhs, double *flv,double *lhs);
  void compute_reactions (long lcid);
  void seisminit (double *seism);
  double get_pd(double time, long dof);
  void tempercontrib (long lcid,double *rhs,long n,double t);
  
  ///  type of dynamic load
  dynload tdl;

  ///  number of subload cases
  long nslc;
  
  ///  number of loaded nodes
  long nln;
  ///  number of loaded elements
  long nle;
  ///  number of prescribed displacements
  long npd;
  
  dloadn  *lon;
  dloadpd *pd;
  
  ///  subload cases
  loadcase *slc;
  ///  time functions
  gfunct *gf;
  ///  seismic tool
  seismtool stool;

};

#endif
