#ifndef GLOBMAT_H
#define GLOBMAT_H

#include "alias.h"
#include "flsubdom.h"

struct matrix;
struct vector;
class problem;


void stiffness_matrix (long lcid);
void mass_matrix (long lcid);
void initial_stiffness_matrix (long lcid);
void damping_matrix ();
void layered_stiffness_matrix ();

void internal_forces (long lcid,double *intfor);
void loc_internal_forces (long lcid,double *intfor);
void nonloc_internal_forces (long lcid,double *intfor);
void incr_internal_forces (long lcid,double *intfor);
void lagrmultcontr_intforces (long lcid,double *intfor);

void nodal_eigstrain_forces (long lcid,double *nodfor);
void elem_eigstrain_forces (long lcid,long eid,vector &nfor);

void eldispl (long lcid,long eid,double *r,long *cn,long ndofe);
void elprdispl (long lcid,long eid,double *r,long *cn,long ndofe);
void noddispl (long lcid,double *r, long nid);
void noddispl (long lcid, long idn, problem *p, double *r);


void constr_matrix (long nid,long cid,matrix &lcm);
void mefel_right_hand_side (long lcid,double *rhs,double *flv=NULL);
void compute_req_val (long lcid);


void local_global_displ_transf (long lcid);
void rhs_graphic (double *rhs,long lcid,long n);

#endif
